<?php
declare(strict_types=1);

namespace Inti\Provider;

use Inti\Container\Factory\PluginManagerFactory;
use Psr\Container\ContainerInterface;

/**
 * Class ConfigProvider
 *
 * @package Inti\Provider
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
final class ConfigProvider
{
    public function __invoke(): array
    {
        return [
            ContainerInterface::class => [
                'factories' => [
                    Service\ProviderManager::class => PluginManagerFactory::class,
                ],
            ],
        ];
    }
}
