<?php
declare(strict_types=1);

namespace Inti\Provider\Service;

use Inti\Provider\ProviderInterface;

/**
 * Interface ProviderManagerInterface
 *
 * @package Inti\Provider\Service
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
interface ProviderManagerInterface
{
    /**
     * @param string $type
     * @param string $providedType
     * @return bool
     */
    public function canProvide(string $type, string $providedType): bool;

    /**
     * @param string $type
     * @param string $providedType
     * @return ProviderInterface|null
     */
    public function getProvider(string $type, string $providedType): ?ProviderInterface;

    /**
     * @param string|null $type
     * @param string|null $providedType
     * @return ProviderInterface[]
     */
    public function getProviders(?string $type = null, ?string $providedType = null): array;

    public function registerProvider(string $provider): void;
    public function registerProviders(array $providers): void;
}
