<?php
declare(strict_types=1);

namespace Inti\Provider\Type;

/**
 * Class AbstractType
 *
 * @package Inti\Provider\Type
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
class AbstractType implements TypeInterface
{
    protected static TypeInterface $instance;

    protected string $name;

    protected function __construct()
    { }

    public function getName(): string
    {
        return $this->name;
    }

    public static function instance(): TypeInterface
    {
        if (!isset(static::$instance)) {
            static::$instance = new static();
        }

        return static::$instance;
    }
}
